from sqlalchemy import *
from migrate import *
import migrate.changeset
from dictionaries.versions import views_helper
import re

def getDiscountsystemTables(meta):
    discountsystem1 = Table('discountsystem1', meta, autoload=True)
    discountsystem2 = Table('discountsystem2', meta, autoload=True)
    return [discountsystem1, discountsystem2]

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    for tbl in getDiscountsystemTables(meta):
        bonusearnsystem = Column('bonusearnsystem', Text, nullable=True)
        bonusearnsystem.create(tbl)
        bonuslimitsystem = Column('bonuslimitsystem', Text, nullable=True)
        bonuslimitsystem.create(tbl)
    views_helper.update_dic_view(migrate_engine, 'discountsystem')


def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    # Operations to reverse the above upgrade go here.
    tblname = views_helper.get_table_name(migrate_engine,'discountsystem')
    conn = migrate_engine.connect()
    for tbl in getDiscountsystemTables(meta):
        tbl.c.bonusearnsystem.drop()
        tbl.c.bonuslimitsystem.drop()
    views_helper.update_dic_view(migrate_engine, 'discountsystem',tblname)
