from sqlalchemy import *
from migrate import *
import migrate.changeset


# role1 = Table('role1', meta, autoload=True)
# role2 = Table('role2', meta, autoload=True)

class Dictionaries(object):
    def __init__(self, isnew, meta):
        if isnew:
            self.role = Table('role', meta,
                              Column('rolecode', Integer, nullable=False, primary_key=True, autoincrement=True),
                              Column('rolename', String(100), nullable=True),
                              )
        else:
            self.role = Table('role', meta,
                              Column('code', Integer, nullable=False, primary_key=True),
                              Column('name', String(255), nullable=True),
                              )
        self.rolerelation = Table('rolerelation', meta,
                                  Column('id', Integer, nullable=False, primary_key=True, autoincrement=True),
                                  Column('primaryrole', Integer, nullable=False),
                                  Column('secondaryrole', Integer, nullable=False),
                                  Column('rule', Integer, nullable=False),
                                  )
        self.roleuser = Table('roleuser', meta,
                              Column('id', Integer, nullable=False, primary_key=True, autoincrement=True),
                              Column('usercode', Integer, nullable=False),
                              Column('rolecode', Integer, nullable=False),
                              Column('rule', Integer, nullable=False),
                              )
        self.rolecmaction = Table('rolecmaction', meta,
                                  Column('id', Integer, nullable=False, primary_key=True, autoincrement=True),
                                  Column('rolecode', Integer, nullable=False),
                                  Column('cmactioncode', Integer, nullable=False),
                                  Column('rule', Integer, nullable=False),
                                  )


def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    conn = migrate_engine.connect()
    view = 'role'
    conn.execute('drop view %s' % (view))
    d = Dictionaries(True, meta)
    basename = d.role.name
    for suffix in ['1', '2']:
        d.role.name = basename + suffix
        d.role.drop()
        d.role.name = basename

    for table in filter(lambda x: isinstance(x, Table), map(lambda x: getattr(d, x), dir(d))):
        basename = table.name
        for suffix in ['1', '2']:
            table.name = basename + suffix
            table.create()
            if suffix == '1':
                conn.execute('create view %s as select * from %s' % (basename, table.name))


def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    # Operations to reverse the above upgrade go here.
    conn = migrate_engine.connect()
    d = Dictionaries(False, meta)
    for table in filter(lambda x: isinstance(x, Table), map(lambda x: getattr(d, x), dir(d))):
        basename = table.name
        conn.execute('drop view %s' % (basename))
        for suffix in ['1', '2']:
            table.name = basename + suffix
            table.drop()
            table.name = basename

    #    d=Dictionaries(False)
    basename = d.role.name
    for suffix in ['1', '2']:
        d.role.name = basename + suffix
        d.role.create()
        if suffix == '1':
            conn.execute('create view %s as select * from %s' % (basename, d.role.name))
