from sqlalchemy import *
from dictionaries.versions import views_helper

tableName = 'certificate'
newColumnName = 'tmccode'
indexName = 'certificateidxrangefrom'

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    for tbl in views_helper.getTables(meta, tableName):
        if indexName not in [ind.name for ind in tbl.indexes]:
            Index(indexName, tbl.c.rangefrom).create()
        if not newColumnName in tbl.columns:
            Column(newColumnName, String(30), nullable = True).create(tbl)
    views_helper.update_dic_view(migrate_engine, tableName)

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    curTableName = views_helper.get_table_name(migrate_engine, tableName)
    for tbl in views_helper.getTables(meta, tableName):
        if newColumnName in tbl.columns:
            tbl.c[newColumnName].drop()
        if indexName in [ind.name for ind in tbl.indexes]:
            Index(indexName, tbl.c.rangefrom).drop()
    views_helper.update_dic_view(migrate_engine, tableName, curTableName)
