from sqlalchemy import *
from migrate import *
from dictionaries.versions import views_helper

supplierTableName = 'supplier'
tmcsupplierTableName = 'tmcsupplier'
tmcsupplierPrimaryKeyIndex = ('tmccode', 'suppliercode')

# если использовать views_helper.getTables, то тест test_incorrect_migrate.py завалится, т.к. условие для его прохождения - разница в количестве полей в таблице
# в этой миграции нет добалвения полей, а только alter
def getTables(meta, tableName):
    return [Table(tableName + "1", meta, autoload=True), Table(tableName + "2", meta, autoload=True)]

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)

    for tbl in getTables(meta, supplierTableName):
        tbl.c.code.alter(type=String(255), nullable=False, primary_key=True)

    for tbl in getTables(meta, tmcsupplierTableName):
        # удаление primary key
        constraint.PrimaryKeyConstraint(*tmcsupplierPrimaryKeyIndex, table=tbl).drop()

        tbl.c.suppliercode.alter(type=String(255), nullable=False)

        # создание primary key
        constraint.PrimaryKeyConstraint(*tmcsupplierPrimaryKeyIndex, table=tbl).create()

    views_helper.update_dic_view(migrate_engine, supplierTableName)
    views_helper.update_dic_view(migrate_engine, tmcsupplierTableName)

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)

    for tbl in getTables(meta, supplierTableName):
        tbl.c.code.alter(type=Integer, autoincrement=True, nullable=False, primary_key=True)

    for tbl in getTables(meta, tmcsupplierTableName):
        # удаление primary key
        constraint.PrimaryKeyConstraint(*tmcsupplierPrimaryKeyIndex, table=tbl).drop()

        tbl.c.suppliercode.alter(type=Integer, nullable=False, autoincrement=False)

        # создание primary key
        constraint.PrimaryKeyConstraint(*tmcsupplierPrimaryKeyIndex, table=tbl).create()

    views_helper.update_dic_view(migrate_engine, supplierTableName)
    views_helper.update_dic_view(migrate_engine, tmcsupplierTableName)
