# -*- coding: utf-8 -*-
from sqlalchemy import *
from migrate import *

def upgrade(migrate_engine):
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    conn = migrate_engine.connect()
    conn.execute("""CREATE VIEW  `shmpositions` AS 
	(SELECT `ws`.`cashcode` AS `cashcode`,  `ws`.`shiftnum` AS `shift`, 
	 `dc`.`checknum` AS `checknum`,  `gi`.`posnum` AS `posnum`,  `gi`.`scode` AS `scode`, 
	 `gi`.`deptcode` AS `dcode`,  `gi`.`ttime` AS `ttime`, 
	 IF((`gi`.`opcode` IN (52,60)),'',`gi`.`code`) AS `code`, 
	 IF((`gi`.`opcode` IN (50,52,1000,1004)),ABS(`gi`.`cquant`),-(ABS(`gi`.`cquant`))) AS `cquant`, 
	 IF((`gi`.`opcode` IN (50,52,1000,1004)),ABS(`gi`.`sumB`),-(ABS(`gi`.`sumB`))) AS `sumb`,  
	 (CASE WHEN ((`gi`.`opcode` IN (50,1000)) AND (`gi`.`cquant` >= 0)) THEN 11 
		 WHEN ((`gi`.`opcode` = 52) AND (`gi`.`cquant` >= 0)) THEN 1 
		 WHEN ((`gi`.`opcode` = 50) AND (`gi`.`cquant` < 0)) THEN 14 
		 WHEN ((`gi`.`opcode` = 52) AND (`gi`.`cquant` < 0)) THEN 4 
		 WHEN (`gi`.`opcode` = 58) THEN 13 
		 WHEN (`gi`.`opcode` = 60) THEN 3 END) AS `opcode`,  
	  IF((`gi`.`opcode` IN (50,52,1000,1004)),ABS(`gi`.`sumn`),-(ABS(`gi`.`sumn`))) AS `sum1`, 
	  IF((`gi`.`opcode` IN (50,52,1000,1004)),ABS(`gi`.`sumi`),-(ABS(`gi`.`sumi`))) AS `sum2`,  
	  (`gi`.`sumi` / `gi`.`cquant`) AS `realprice`, 
	  `gi`.`price` AS `price1`,  
	  `gi`.`pricei` AS `price2`, 
	  `gi`.`tindex` AS `tindex`
	  FROM `goodsitem` `gi`,`workshift` `ws`,`document` `dc`
	  WHERE `ws`.`workshiftid` = `dc`.`workshiftid` AND `dc`.`documentid` = `gi`.`documentid` and `dc`.`closed` = 1)""")
    conn.execute(""" CREATE VIEW `shmstorno` AS 
	SELECT  `ws`.`cashcode` AS `cashcode`,  
	`ws`.`shiftnum` AS `shift`,  `dc`.`checknum` AS `checknum`, 
	`sg`.`posnum` AS `posnum`,  `sg`.`scode` AS `scode`,  
	`sg`.`deptcode` AS `dcode`,  `sg`.`timestorno` AS `tstime`,  
	IF((`sg`.`opcode` IN (52,60)),'',`sg`.`code`) AS `code`,  
	IF((`sg`.`opcode` IN (50,52,1000)),-(ABS(`sg`.`cquant`)),ABS(`sg`.`cquant`)) AS `cquant`,  
	IF((`sg`.`opcode` IN (50,52,1000)),-(ABS(`sg`.`sumb`)),ABS(`sg`.`sumb`)) AS `sumb`, 
	(`sg`.`sumb` / `sg`.`cquant`) AS `price`,  
	IF((`sg`.`opcode` IN (50,58,1000)),12,2) AS `opcode` 
	FROM `stornogoodsitem` `sg`,`workshift` `ws`,`document` `dc`
	WHERE `ws`.`workshiftid` = `dc`.`workshiftid` AND `dc`.`documentid` = `sg`.`documentid`""")
    conn.execute(""" CREATE VIEW `shmpositionsstorno` AS
	SELECT  `ws`.`cashcode` AS `cashcode`,
	`ws`.`shiftnum` AS `shift`,  `dc`.`checknum` AS `checknum`, 
	`sg`.`posnum` AS `posnum`,  `sg`.`scode` AS `scode`,  
	`sg`.`deptcode` AS `dcode`,  `sg`.`tstime` AS `tstime`,  
	IF((`sg`.`opcode` IN (52,60)),'',`sg`.`code`) AS `code`,  
	IF((`sg`.`opcode` IN (50,52,1000)),ABS(`sg`.`cquant`),-(ABS(`sg`.`cquant`))) AS `cquant`,  
	IF((`sg`.`opcode` IN (50,52,1000)),ABS(`sg`.`sumb`),-(ABS(`sg`.`sumb`))) AS `sumb`,  
	(`sg`.`sumb` / `sg`.`cquant`) AS `price`,  
	(CASE WHEN ((`sg`.`opcode` IN (50,1000)) AND (`sg`.`cquant` >= 0)) THEN 11 
	      WHEN ((`sg`.`opcode` = 52) AND (`sg`.`cquant` >= 0)) THEN 1 
	      WHEN ((`sg`.`opcode` = 50) AND (`sg`.`cquant` < 0)) THEN 14 
	      WHEN ((`sg`.`opcode` = 52) AND (`sg`.`cquant` < 0)) THEN 4 
	      WHEN (`sg`.`opcode` = 58) THEN 13 
	      WHEN (`sg`.`opcode` = 60) THEN 3 END) AS `opcode` 
	FROM `stornogoodsitem` `sg`,`workshift` `ws`,`document` `dc`
	WHERE `ws`.`workshiftid` = `dc`.`workshiftid` AND `dc`.`documentid` = `sg`.`documentid`""")
    conn.execute("""CREATE VIEW `shmmoneyoperations` AS 
	SELECT  `ws`.`cashcode` AS `cashcode`,  
	`ws`.`shiftnum` AS `shift`,  `dc`.`checknum` AS `checknum`, 
	`dc`.`time_end` AS `mtime`,  `dc`.`scode` AS `scode`, 
	IF((`dc`.`doctype` = 3),50,51) AS `opcode`,  
	`dc`.`sumb` AS `msum` 
	FROM `workshift` `ws`,`document` `dc`
	WHERE `ws`.`workshiftid` = `dc`.`workshiftid` and `dc`.`closed` = 1 AND (`dc`.`doctype` IN(3,4)) """)	
    conn.execute("""CREATE VIEW `shmdiscounts` AS 
	SELECT   
	`ws`.`cashcode` AS `cashcode`, 
	`ws`.`shiftnum` AS `shift`, 
	`dc`.`checknum` AS `checknum`, 
	IF((`di`.`ispositiondiscount` = 1),`di`.`positionnum`,10000) AS `posnum`,  
	(`di`.`discnumber` * 2) AS `dnum`,  
	`di`.`dtime` AS `dtime`,  
	COALESCE(`gi`.`deptcode`,0) AS `dcode`,  
	`di`.`scode` AS `scode`,  
	((IF((`di`.`disctype` = 1),17,15) + IF((`di`.`ispositiondiscount` = 1),0,20)) + IF((`di`.`discsum` < 0),1,0)) AS `opcode`,  
	COALESCE(`gi`.`code`,0) AS `code`,  
	IF((`di`.`disctype` = 3),ABS(`di`.`discsum`),ABS((`di`.`discsize`))) AS `dsize`,  
	IF((`dc`.`doctype` = 1),ABS(`di`.`discsum`),-(ABS(`di`.`discsum`))) AS `dsum` 
	FROM `discitem` `di`,`workshift` `ws`,`document` `dc`,`goodsitem` `gi`
	WHERE `ws`.`workshiftid` = `dc`.`workshiftid` AND `dc`.`documentid` = `gi`.`documentid`
	AND `gi`.`goodsitemid` = `di`.`goodsitemid` and `dc`.`closed` = 1 """)
    conn.execute("""CREATE  VIEW `shmdiscountsext` AS 
	SELECT  
	`ws`.`cashcode` AS `cashcode`,  
	`ws`.`shiftnum` AS `shift`,  
	`dc`.`checknum` AS `checknum`,  
	`di`.`positionnum` AS `posnum`, 
	(`di`.`discnumber` * 2) AS `dnum`,  
	`di`.`dtime` AS `dtime`,  
	COALESCE(`gi`.`deptcode`,0) AS `dcode`,  
	`di`.`scode` AS `scode` ,
	(IF((`di`.`disctype` = 1),17,15) + IF((`di`.`discsum` < 0),1,0)) AS `opcode`,  
	COALESCE(`gi`.`code`,0) AS `code`,  
	IF((`di`.`disctype` = 3),ABS(`di`.`discsum`),ABS((`di`.`discsize`))) AS `dsize`,
	IF((`dc`.`doctype` = 1),ABS(`di`.`discsum`),-(ABS(`di`.`discsum`))) AS `dsum` 
	FROM `discitem` `di`,`workshift` `ws`,`document` `dc`,`goodsitem` `gi`
	WHERE `ws`.`workshiftid` = `dc`.`workshiftid` AND `dc`.`documentid` = `gi`.`documentid`
	AND `gi`.`goodsitemid` = `di`.`goodsitemid` and `dc`.`closed` = 1 """)
    conn.execute(""" CREATE VIEW `shmdiscountsdetail` AS 
	SELECT   `ws`.`cashcode` AS `cashcode`,  
	`ws`.`shiftnum` AS `shift`, 
	`dc`.`checknum` AS `checknum`, 
	IF((`di`.`ispositiondiscount` = 1),`di`.`positionnum`,10000) AS `posnum`,  
	((`di`.`discnumber` * 2) + 1) AS `dnum`,  
	`di`.`dtime` AS `dtime`,  
	`di`.`scode` AS `scode`, 
	IF((`di`.`ispositiondiscount` = 1),70,71) AS `opcode`, 
	IF((`dc`.`doctype` = 1),ABS((`di`.`discsum`)),-(ABS((`di`.`discsum`)))) AS `dsum`,
	(CASE `di`.`discmode` WHEN 1 THEN `di`.`discscheme` 
		 WHEN 2 THEN `di`.`cardnumber` 
		 WHEN 5 THEN `di`.`discscheme` 
		 ELSE 0 END) AS `dprm1`,  
	(CASE `di`.`discmode` WHEN 1 THEN 2 
		 WHEN 2 THEN 3 
		 WHEN 3 THEN 1 
		 WHEN 5 THEN 2 
		 ELSE 0 END) AS `dtype`,  
	(CASE `di`.`discmode` WHEN 1 THEN `di`.`disccode` 
		 WHEN 2 THEN ABS(`dc`.`sumb`) 
		 WHEN 5 THEN `di`.`disccode` 
		 ELSE 0 END) AS `dprm2`,  
	IF((`di`.`ispositiondiscount` = 1),IF((`di`.`checksum` = 0),0,ABS(((`di`.`discsum` / `di`.`checksum`) * 100))),IF((`dc`.`sumb` = 0),0,ABS(((`di`.`discsum` / `dc`.`sumb`) * 100)))) AS `dprm3` 
	FROM `discitem` `di`,`workshift` `ws`,`document` `dc`,`goodsitem` `gi`
	WHERE `ws`.`workshiftid` = `dc`.`workshiftid` AND `dc`.`documentid` = `gi`.`documentid`
	AND `gi`.`goodsitemid` = `di`.`goodsitemid` AND  `di`.`ispositiondiscount` = 1 and `dc`.`closed` = 1""")
    conn.execute(""" CREATE VIEW `shmdiscountsdetailext` AS 
	  SELECT
 	  `ws`.`cashcode`    AS `cashcode`,
	  `ws`.`shiftnum`    AS `shift`,
	  `dc`.`checknum`    AS `checknum`,
	  `di`.`positionnum` AS `posnum`,
	  ((`di`.`discnumber` * 2) + 1) AS `dnum`,
	  `di`.`dtime`       AS `dtime`,
	  `di`.`scode`       AS `scode`,
	  70                 AS `opcode`,
	  IF((`dc`.`doctype` = 1),ABS(`di`.`discsum`),-(ABS(`di`.`discsum`))) AS `dsum`,
	  (CASE `di`.`discmode` WHEN 1 THEN `di`.`discscheme` WHEN 2 THEN `di`.`cardnumber` WHEN 5 THEN `di`.`discscheme` ELSE 0 END) AS `dprm1`,
	  (CASE `di`.`discmode` WHEN 1 THEN 2 WHEN 2 THEN 3 WHEN 3 THEN 1 WHEN 5 THEN 2 ELSE 0 END) AS `dtype`,
	  (CASE `di`.`discmode` WHEN 1 THEN `di`.`disccode` WHEN 2 THEN ABS(`dc`.`sumb`) WHEN 5 THEN `di`.`disccode` ELSE 0 END) AS `dprm2`,
	  ABS(((`di`.`discsum` / IF((`di`.`checksum` = 0),1,`di`.`checksum`)) * 100)) AS `dprm3`
	FROM `discitem` `di`,`workshift` `ws`,`document` `dc`,`goodsitem` `gi`
	WHERE `ws`.`workshiftid` = `dc`.`workshiftid` AND `dc`.`documentid` = `gi`.`documentid`
	AND `gi`.`goodsitemid` = `di`.`goodsitemid` AND  `di`.`ispositiondiscount` = 1 and `dc`.`closed` = 1""")	
def downgrade(migrate_engine):                                                                              
    # Operations to reverse the above upgrade go here.
    conn = migrate_engine.connect()
    conn.execute('drop view shmpositions')
    conn.execute('drop view shmstorno')
    conn.execute('drop view shmpositionsstorno')
    conn.execute('drop view shmmoneyoperations')
    conn.execute('drop view shmdiscounts')
    conn.execute('drop view shmdiscountsext')
    conn.execute('drop view shmdiscountsdetail')
    conn.execute('drop view shmdiscountsdetailext')
