from sqlalchemy import *
from migrate import *
from documents.versions import dump

def getTablesGoods(meta):
    return Table('goodsitem', meta, autoload=True), Table('stornogoodsitem', meta, autoload=True)

def getTableAspectItem(meta):
    return Table('aspectitem', meta, autoload=True)

def upgrade(migrate_engine):

    meta = MetaData(bind = migrate_engine)
    dump.store(migrate_engine)

    for tbl in getTablesGoods(meta):
        if not 'aspectschemecode' in tbl.columns:
            Column('aspectschemecode', Integer, nullable=True).create(tbl)
        if not 'aspectvaluesetcode' in tbl.columns: 
            Column('aspectvaluesetcode', Integer, nullable=True).create(tbl)

    if not 'aspectorder' in getTableAspectItem(meta).columns:
        Column('aspectorder', Integer, nullable=True).create(getTableAspectItem(meta))
    if not 'aspectname' in getTableAspectItem(meta).columns:
        Column('aspectname', String(255), nullable=True).create(getTableAspectItem(meta))
    if not 'aspectvaluename' in getTableAspectItem(meta).columns:
        Column('aspectvaluename', String(255), nullable=True).create(getTableAspectItem(meta))

def downgrade(migrate_engine):

    meta = MetaData(bind = migrate_engine)

    if 'aspectvaluename' in getTableAspectItem(meta).columns:
        getTableAspectItem(meta).c.aspectvaluename.drop()
    if 'aspectname' in getTableAspectItem(meta).columns:
        getTableAspectItem(meta).c.aspectname.drop()
    if 'aspectorder' in getTableAspectItem(meta).columns:
        getTableAspectItem(meta).c.aspectorder.drop()

    for tbl in getTablesGoods(meta):
        if 'aspectvaluesetcode' in tbl.columns:
            tbl.c.aspectvaluesetcode.drop()
        if 'aspectschemecode' in tbl.columns:
            tbl.c.aspectschemecode.drop()
