# -*- coding: utf-8 -*-
from sqlalchemy import *
from migrate import *
from documents.versions import dump

def getTable(meta):
    return Table('carditem', meta, autoload=True)

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    dump.store(migrate_engine)
    column = Column('cardstatus', Integer, nullable=True)
    if column.name not in getTable(meta).columns:
        column.create(getTable(meta))

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    if 'cardstatus' in getTable(meta).columns:
        getTable(meta).c.cardstatus.drop()