from sqlalchemy import *
from migrate import *

def getTable(meta):
    return Table('paymentitem', meta, autoload=True)

def upgrade(migrate_engine):
    # Upgrade operations go here. Don't create your own engine; bind migrate_engine
    # to your metadata
    meta = MetaData(bind=migrate_engine)

    for col in ['paymentsysteminfo' ,'organizationinfo', 'providerinfo']:
        if not col in getTable(meta).columns:
            Column(col, String(250), nullable=True).create(getTable(meta))

def downgrade(migrate_engine):
    # Operations to reverse the above upgrade go here.
    meta = MetaData(bind=migrate_engine)
    if 'paymentsysteminfo' in getTable(meta).columns:
        getTable(meta).c.paymentsysteminfo.drop()
    if 'organizationinfo' in getTable(meta).columns:
        getTable(meta).c.organizationinfo.drop()
    if 'providerinfo' in getTable(meta).columns:
        getTable(meta).c.providerinfo.drop()