from sqlalchemy import *
from migrate import *
from documents.versions import dump


def getTables(meta):
    return Table('goodsitem', meta, autoload=True), Table('stornogoodsitem', meta, autoload=True)


def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    dump.store(migrate_engine)
    for tbl in getTables(meta):
        if not 'additionalexcisemark' in tbl.columns:
            Column('additionalexcisemark', String(50), nullable=True).create(tbl)


def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    for tbl in getTables(meta):
        if 'additionalexcisemark' in tbl.columns:
            Column('additionalexcisemark', String(50), nullable=True).drop(tbl)