from sqlalchemy import *
from migrate import *

try:
    from sqlalchemy.dialects.mysql.base import MSMediumText
except:
    from sqlalchemy.databases.mysql import MSMediumText

def getWorkshift(meta):
    return Table('workshift', meta, autoload=True)

def getReportTable(meta):
    return Table('report', meta,
        Column('reportid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('workshiftid', Integer, ForeignKey(getWorkshift(meta).c.workshiftid, name='reportworkshiftidfk',
                ondelete='CASCADE'), nullable=False),
        Column('name', String(255), nullable=False, index=True),
        Column('reportdatetime', DateTime, nullable=False, index=True),
        Column('rawdata', MSMediumText(), nullable=False),
        Column('reporttext', MSMediumText(), nullable=False),
        mysql_engine='InnoDB'
    )

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    reportTable = getReportTable(meta)
    if not reportTable.exists(meta.bind):
        reportTable.create()

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    reportTable = getReportTable(meta)
    if reportTable.exists(meta.bind):
        reportTable.drop()
